LAST(1)

NAME
last - indicate last logins of users, ttys, and hosts

SYNOPSIS
last [-csT] [-d date] [-f file] [-h host] [-n number] [-t tty] [user ...]

DESCRIPTION
The last utility will either list the sessions of specified users, ttys, and hosts, in reverse time order, or list the users logged in at a specified snapshot date and time in reverse time order. Each line of output contains the user name, the tty from which the session was conducted, any hostname, the start and stop times for the session, and the duration of the session. If the session is still continuing or was cut short by a crash or shutdown, last will so indicate.

The options are as follows:

-c  Calculates the total time displayed and prints it after the output.

-d date
    Specify the snapshot date and time. All users logged in at the snapshot date and time will be reported. This may be used with the -f option to derive the results from stored wtmp files. When this argument is provided, all other options except for -f and -n are ignored. The argument should be in the form “[[[CC]YY]MMDD]hhmm[.SS]” where each pair of letters represents the following:

    CC  The first two digits of the year (the century).
    YY  The second two digits of the year. If “YY” is specified, but “CC” is not, a value for “YY” between 69 and 99 results in a “CC” value of 19. Otherwise, a “CC” value of 20 is used.
    MM  Month of the year, from 1 to 12.
    DD  Day of the month, from 1 to 31.
    hh  Hour of the day, from 0 to 23.
    mm  Minute of the hour, from 0 to 59.
    SS  Second of the minute, from 0 to 61.

    All but the “hh” and “mm” letter pairs are optional. If the “CC” and “YY” letter pairs are not specified, the values default to the current year. If the “MM” and “DD” letter pairs are not specified, the values default to the current month and day. If the “SS” letter pair is not specified, the value defaults to 0.

-f file
    last reads the file file instead of the default, /var/log/wtmp.

-h host
    host names may be names or internet numbers.

-n number
    Limits the report to number lines. The format -number is also supported, but is deprecated.

-s  Display time values in seconds since the Epoch, instead of formatted dates.

-T  Display better time information, including seconds.

-t tty
    Specify the tty. tty names may be given fully or abbreviated, for example, last -t 03 is equivalent to last -t tty03.

If multiple arguments are given, and a snapshot time is not specified, the information which applies to any of the arguments is printed, e.g., last root -t console would list all of root's sessions as well as all sessions on the console terminal. If no users, hostnames, or terminals are specified, last prints a record of all logins and logouts.

The pseudo-user “reboot” logs in at reboots of the system; thus last reboot will give an indication of mean time between reboot.

If last is interrupted, it indicates to what date the search has progressed. If interrupted with a quit signal, last indicates how far the search has progressed and then continues.

FILES
/var/log/wtmp
    login database

SEE ALSO
lastcomm(1), utmp(5), ac(8)

HISTORY
The last utility first appeared in 1BSD.

AUTHORS
-nosplit The original version was written by Howard P. Katseff; Keith Bostic rewrote it in 1986/87 to add functionality and to improve code quality.